Components.utils.import("resource://gre/modules/Services.jsm");

var pref = Services.prefs.getBranch("extensions.autohide.");
var aWin = Services.wm.getMostRecentWindow("navigator:browser");

var topBars, bottomBars, d=document, dE, boxes, numbers, winUtil=false;

function initPref() {
  dE = d.documentElement;

  if (!aWin) {
    alert(dE.getAttribute("aherror"));
    dE.cancelDialog();
    return false;
  }

  try {
    Components.utils.import("resource://autohide/systemHooks.js");
    winUtil = autoHIDESystemHook.winUtil;
  }

  catch (err) {}

  topBars = aWin.document.getElementById("navigator-toolbox").childNodes;
  bottomBars = aWin.document.getElementById("browser-bottombox").childNodes;

  return true;
}

function savePrefs() {
  pref.deleteBranch("bars.");

  for (var b=0; b < boxes.length; b++)
    pref.setBoolPref(boxes[b].id, boxes[b].checked);

  for (var n=0; n < numbers.length; n++)
    pref.setIntPref(numbers[n].id, numbers[n].value);

  return true;
}

function insertRow(id, label) {
  var row = d.createElement("row");
  var cb = d.createElement("checkbox");
  cb.id = "bars." + id;
  cb.setAttribute("label", label);
  row.appendChild(cb);
  var box = d.createElement("hbox");
  var spa = d.createElement("spacer");
  spa.setAttribute("flex", 1);
  box.appendChild(spa);
  cb = d.createElement("checkbox");
  cb.id = "bars." + id + ".always";
  box.appendChild(cb);
  box.appendChild(spa.cloneNode(true));
  row.appendChild(box);
  d.getElementById("ahBars").insertBefore(row, d.getElementById("winTaskRow"));
}

function fill(boxChildren) {
  for (var k=0; k < boxChildren.length; k++) {
    if (boxChildren[k].localName && (boxChildren[k].localName == "toolbar" || boxChildren[k].localName == "menubar")) {
      var toolbarLabel = "";

      if (boxChildren[k].hasAttribute("toolbarname"))
        toolbarLabel = boxChildren[k].getAttribute("toolbarname");
      else if (boxChildren[k].hasAttribute("grippytooltiptext"))
        toolbarLabel = boxChildren[k].getAttribute("grippytooltiptext");
      else {
        if (boxChildren[k].id == "toolbar-menubar")
          toolbarLabel = dE.getAttribute("ahmenu");

        if (boxChildren[k].id == "TabsToolbar")
          toolbarLabel = dE.getAttribute("ahtabs");

        if (toolbarLabel == "")
          toolbarLabel = boxChildren[k].id.slice(0,1).toUpperCase() + boxChildren[k].id.substring(1, boxChildren[k].id.length).toLowerCase();
      }

      insertRow(boxChildren[k].id, toolbarLabel);
    }
  }
}

function setBoxes() {
  boxes = d.getElementsByTagName("checkbox");

  for (var k=0; k < boxes.length; k++) {
    try {
      boxes[k].checked = pref.getBoolPref(boxes[k].id);
    }
    catch (e) {}
  }

  if (winUtil && winUtil.supports("systemTaskBar"))
    d.getElementById("semiMode").disabled = winUtil.isAutoHidden() ? true : false;
  else
    d.getElementById("winTaskRow").hidden = true;

  if (!winUtil)
    d.getElementById("hideTitleBar").hidden = true;
}

function setNumbers() {
  numbers = d.getElementsByTagName("textbox");

  for (var k=0; k < numbers.length; k++) {
    try {
      numbers[k].value = pref.getIntPref(numbers[k].id);
    }
    catch (e) {}
  }
}