Components.utils.import("resource://gre/modules/Services.jsm");

var autoHIDE = {
  pref   : Services.prefs.getBranch("extensions.autohide."),
  zombie : false,
  init   : false,
  handle : null,

  GetBoolPref : function(v) {
    try {
      return this.pref.getBoolPref(v)
    }
    catch (e) {
      return false
    }
  },

  MouseObserver : {
    observe : function (subject, topic, data) {
      if (!autoHIDE.winUtil.isMouseOver(autoHIDE.handle))
        return;

      if (topic == "ahMouseMove") {
        var mData = data.split("|");
        var evt = document.createEvent("MouseEvents");
        evt.initMouseEvent("mousemove", 1, 1, window, 0,
                           mData[0], mData[1], 0, 0, 0, 0, 0, 0, 0, window);

        autoHIDE.EL_MouseMove(evt);
      }
    }
  },

  GetCMDLine : function() {
    if (this.init)
      return;

    var ah = autoHIDE;
    ah.init = true;
    ah.mainWin = document.getElementById("main-window");
    ah.bc = document.getElementById("autoHIDE_BC");

    while (document.getElementsByAttribute("autoHIDE_BC", "*").length) {
      var elt = document.getElementsByAttribute("autoHIDE_BC", "*")[0];
      elt.setAttribute("observes", "autoHIDE_BC");
      elt.removeAttribute("autoHIDE_BC");
    }

    document.getElementById("contentAreaContextMenu")
            .addEventListener("popupshowing", function(e){autoHIDE.EL_Context(e)}, true);

    addEventListener("unload", function() {
      var ah = autoHIDE;
      ah.pref.setBoolPref("openFull", fullScreen);
      ah.pref.setBoolPref("openZombie", ah.zombie);

      if (fullScreen && ah.winState)
        ah.mainWin.setAttribute("sizemode", ah.winState);

      try {
        Services.obs.removeObserver(ah.MouseObserver, "ahMouseMove");
      }
      catch (e) {}
    }, false);

    var winEnum = Services.wm.getEnumerator("navigator:browser");
    winEnum.getNext();

    if (!winEnum.hasMoreElements()) {
      ah.openFull = ah.GetBoolPref("openFull");
      ah.openZombie = ah.GetBoolPref("openZombie");
    }
    else if ("arguments" in window) {
      if (window.opener)
        ah.lastWin = window.opener;
      else {
        winEnum = Services.wm.getZOrderDOMWindowEnumerator("navigator:browser", true);
        winEnum.getNext();
        ah.lastWin = winEnum.getNext();
      }

      if (ah.lastWin) {
        if (ah.GetBoolPref("newFull")) {
          if (ah.lastWin.fullScreen)
            ah.openFull = true;

          if (ah.lastWin.autoHIDE) {
            if (ah.lastWin.autoHIDE.zombie)
              ah.openZombie = true;

            if (ah.openFull && ah.lastWin.autoHIDE.winState && ah.lastWin.autoHIDE.winState == "maximized")
              ah.openMaximized = true;
          }
        }
        else if (ah.lastWin.fullScreen && ah.lastWin.autoHIDE && ah.lastWin.autoHIDE.winState) {
          ah.mainWin.setAttribute("sizemode", ah.lastWin.autoHIDE.winState);

          if (ah.lastWin.autoHIDE.winState == "maximized")
            setTimeout(window.maximize, 0);
        }

        delete ah.lastWin;
      }
    }

    try {
      Components.utils.import("resource://autohide/systemHooks.js");
      ah.winUtil = autoHIDESystemHook.winUtil;

      window.focus();
      ah.handle = ah.winUtil.winInit();

      if (ah.openFull || ah.openZombie)
        setTimeout("fullScreen=true", 0);
    }
    catch (err) {
      ah.winUtil = false;

      if (ah.openFull || ah.openZombie)
        setTimeout("fullScreen=true", 500);
    }
  },

  ToggleTop : function(toolBars) {
    var ah = autoHIDE;

    if (ah.topVis) {
      ah.ResetTop();

      if (!ah.noFloat)
        ah.MoveContent(false);

      return;
    }

    if (ah.noFloat)
      ah.SetTop(toolBars);
    else {
      var br = gBrowser.mCurrentBrowser;
      ah.delta = br.boxObject.y;

      if (ah.winUtil)
        ah.winUtil.setRedraw(ah.handle, false);

      ah.SetTop(toolBars);
      ah.delta = br.boxObject.y - ah.delta;
      ah.MoveContent(true);

      if (ah.winUtil)
        ah.winUtil.setRedraw(ah.handle, true);
    }
  },

  MoveContent : function(aMove) {
    var ah = autoHIDE

    if (!ah.noFloat) {
      var br = gBrowser.mCurrentBrowser;

      if (aMove && !gInPrintPreviewMode) {
        if (!br.ahMarginSet) {
          br.ahMarginOld = getComputedStyle(br, null).getPropertyValue("margin-top");
          br.style.marginTop = parseFloat(br.ahMarginOld) - ah.delta + "px";
          br.ahMarginSet = true;
        }
      }
      else {
        if (br.ahMarginSet)
          ah.ResetMove(br);

        var brs = gBrowser.browsers;

        for (var b = 0; b < brs.length; b++) {
          if (brs[b].ahMarginSet && brs[b] != br)
            ah.ResetMove(brs[b]);
        }
      }
    }
  },

  ResetMove : function(aBrowser) {
    aBrowser.style.marginTop = aBrowser.ahMarginOld;
    aBrowser.ahMarginSet = false;
  },

  SetTop : function(toolBars) {
    var ah = autoHIDE;

    if (toolBars) {
      for (var each in toolBars) {
        var elt = document.getElementById(each);
        elt.setAttribute("ahHIDE", false);

        if (elt.hasAttribute("ahPREVCOLLAPSED"))
          elt.setAttribute("collapsed", false);
      }
    }
    else {
      for (var x=0; x < ah.navBoxC.length; x++) {
        if (ah.GetBoolPref("bars." + ah.navBoxC[x].id + ".always")) {
          ah.navBoxC[x].setAttribute("ahHIDE", false);

          if (ah.navBoxC[x].hasAttribute("ahPREVCOLLAPSED"))
            ah.navBoxC[x].setAttribute("collapsed", false);

          continue;
        }

        ah.navBoxC[x].setAttribute("ahHIDE", !ah.GetBoolPref("bars." + ah.navBoxC[x].id));

        if (ah.navBoxC[x].hasAttribute("ahPREVCOLLAPSED"))
          ah.navBoxC[x].setAttribute("collapsed", ah.navBoxC[x].getAttribute("ahHIDE"));
      }
    }

    ah.navBox.setAttribute("ahHIDE", false);
    ah.mainWin.setAttribute("ahHIDETITLEBAR", (ah.tabBar.getAttribute("ahHIDE") == "true" &&
                                               ah.menuBar.getAttribute("ahHIDE") == "true") ? true : false);

    ah.topVis = true;
  },

  ResetTop : function(aBool) {
    var ah = autoHIDE;
    ah.navBox.setAttribute("ahHIDE", true);

    for (var x=0; x < ah.navBoxC.length; x++) {
      if (ah.GetBoolPref("bars." + ah.navBoxC[x].id + ".always")) {
        ah.navBox.setAttribute("ahHIDE", false);
        ah.navBoxC[x].setAttribute("ahHIDE", false);
        continue;
      }

      ah.navBoxC[x].setAttribute("ahHIDE", true);

      if (ah.navBoxC[x].hasAttribute("ahPREVCOLLAPSED"))
        ah.navBoxC[x].setAttribute("collapsed", true);
    }

    ah.topVis = false;
    ah.mainWin.setAttribute("ahHIDETITLEBAR", (ah.tabBar.getAttribute("ahHIDE") == "true" &&
                                               ah.menuBar.getAttribute("ahHIDE") == "true"));

    setTimeout(ah.HandleHiddenActive, 0, ah.navBox);

    if (aBool)
      ah.ResetBottom();

    if (aBool && ah.winUtil) {
      var hideTitle = ah.GetBoolPref("hideTitleBar");
      hideTitle = (hideTitle && ah.zombie && ah.mainWin.getAttribute("tabsintitlebar")) ? false : hideTitle;

      ah.winUtil.setPrefs(ah.pref.getIntPref("delay"),
                          hideTitle,
                          ah.GetBoolPref("windowsTB"));

      var mode = (ah.zombie) ? 3 : ((ah.GetBoolPref("semiMode") && !ah.winUtil.isAutoHidden()) ? 2 : 1);

      ah.winUtil.goFull(ah.handle, mode);

      if (ah.zombie && hideTitle) {
        document.getElementById("window-controls").setAttribute("ahHIDE", false);

        if (ah.chromeMargin) {
          ah.mainWin.removeAttribute('chromemargin');
          ah.titleBar.setAttribute("ahHIDE", true);
          ah.withoutCaption = true
        }
      }
    }
  },

  ToggleBottom : function(toolBars) {
    var ah = autoHIDE

    if (ah.bottomVis) {
      ah.ResetBottom();
      return;
    }
    else
      ah.SetBottom(toolBars);
  },


  SetBottom : function(toolBars) {
    var ah = autoHIDE

    if (toolBars) {
      for (var each in toolBars)
        document.getElementById(each).setAttribute("ahHIDE", false);
    }
    else {
      for (var x=0; x < ah.botBoxC.length; x++) {
        if (!ah.botBoxC[x].hasAttribute("ahPOS"))
          continue;

        if (ah.GetBoolPref("bars." + ah.botBoxC[x].id + ".always")) {
          ah.botBoxC[x].setAttribute("ahHIDE", false);
          continue;
        }

        ah.botBoxC[x].setAttribute("ahHIDE", !ah.GetBoolPref("bars." + ah.botBoxC[x].id));
      }
    }

    ah.bottomVis = true;
  },

  ResetBottom : function() {
    var ah = autoHIDE;

    for (var x=0; x < ah.botBoxC.length; x++) {
      if (!ah.botBoxC[x].hasAttribute("ahPOS"))
        continue;

      if (ah.GetBoolPref("bars." + ah.botBoxC[x].id + ".always")) {
        ah.botBox.setAttribute("ahHIDE", false);
        ah.botBoxC[x].setAttribute("ahHIDE", false);
        continue;
      }

      ah.botBoxC[x].setAttribute("ahHIDE", true);
    }

    ah.bottomVis = false;
    setTimeout(ah.HandleHiddenActive, 0, ah.botBox);
  },

  HandleHiddenActive : function(aBox) {
    var ah = autoHIDE;

    if (ah.menuBar.getElementsByAttribute("_moz-menuactive", "*").length &&
        ah.menuBar.getAttribute("ahHIDE") == "true") {
      var evt = document.createEvent("KeyboardEvent");
      evt.initKeyEvent("keydown", 0, 0, null, 0, true, 0, 0, 18, 0);
      ah.menuBar.dispatchEvent(evt);
    }

    var aNode = document.activeElement;

    while (aNode != null && aNode != aBox && aNode != document) {
      if (aNode.getAttribute("ahHIDE") == "true") {
        var fm = Components.classes["@mozilla.org/focus-manager;1"]
                 .getService(Components.interfaces.nsIFocusManager);

        setTimeout(fm.clearFocus, 0, window);
        break;
      }

      aNode = aNode.parentNode;
    }
  },

  InitBoxChildren : function(aBoxC, aPos) {
    for (var x=0; x < aBoxC.length; x++) {
      if (aBoxC[x].localName.toLowerCase() != "toolbar")
        continue;

      aBoxC[x].setAttribute("ahPOS", aPos);

      if (aBoxC[x].hasAttribute("collapsed")) {
        if (aBoxC[x].id != "TabsToolbar")
          aBoxC[x].setAttribute("ahPREVCOLLAPSED", aBoxC[x].getAttribute("collapsed"));
      }
    }
  },

  InitHide : function(e) {
    var ah = autoHIDE;
    function $(id) document.getElementById(id);

    if (!fullScreen && !ah.zombie) {
      ah.topArea = ah.pref.getIntPref("topArea");
      ah.bottomArea = ah.pref.getIntPref("bottomArea");

      if (ah.GetBoolPref("zombieMode") || ah.openZombie || (ah.winUtil && ah.winUtil.isShiftDown())) {
        ah.zombie = true;
        e.preventDefault();
        e.stopPropagation();
        ah.topArea -= 2;
        ah.bottomArea -= 2;
      }

      ah.navBox = $("navigator-toolbox");
      ah.navBoxC = ah.navBox.childNodes;
      ah.botBox = $("browser-bottombox");
      ah.botBoxC = ah.botBox.childNodes;

      ah.InitBoxChildren(ah.navBoxC, "top");
      ah.InitBoxChildren(ah.botBoxC, "bottom");

      ah.winState = ah.mainWin.getAttribute("sizemode");
      ah.openZombie = ah.bottomVis = false;
      ah.delay = ah.pref.getIntPref("delay");
      ah.hideDelay = ah.pref.getIntPref("hideDelay");
      ah.noFloat = ah.GetBoolPref("noFloat");
      ah.menuBar = $("toolbar-menubar");
      ah.titleBar = $("titlebar");
      ah.tabBar = $("TabsToolbar");
      ah.tabViewDeck = $("tab-view-deck");

      gBrowser.tabContainer.addEventListener("TabSelect", ah.EL_TabSelect, false);
      ah.tabViewDeck.addEventListener("select", ah.EL_TabDeckSelect, true);

      if (ah.winUtil)
        Services.obs.addObserver(ah.MouseObserver, "ahMouseMove", false);
      else
        addEventListener("mousemove", ah.EL_MouseMove, true);

      ah.menuBar.addEventListener("DOMMenuBarActive", ah.EL_MenuBar, true);
      ah.menuBar.addEventListener("DOMMenuBarInactive", ah.EL_MenuBar, true);
      addEventListener("popupshown", ah.EL_Popup, false);
      addEventListener("popuphidden", ah.EL_Popup, false);
      addEventListener("keypress", ah.EL_Input, true);
      addEventListener("DOMNodeInserted", ah.EL_Print, false);
      addEventListener("DOMNodeRemoved", ah.EL_Print, false);

      if (!ah.commandsChanged) {
        ah.ChangeCommand(["Browser:OpenLocation", "cmd_newNavigatorTab", "focusURLBar"],
                          "if (fullScreen || autoHIDE.zombie) autoHIDE.EL_Location('urlbar'); ");

        ah.ChangeCommand(["cmd_newNavigatorTab"],
                          "if (fullScreen || autoHIDE.zombie) autoHIDE.EL_Location('TabsToolbar'); ");

        ah.ChangeCommand(["Tools:Search"],
                          "if (fullScreen || autoHIDE.zombie) autoHIDE.EL_Location('search-container'); ");

        ah.ChangeCommand(["titlebar-max"],
                          "if (autoHIDE.zombie) {window.fullScreen=true; return;} ");

        ah.commandsChanged = true;

        try {
          var pti = $("PlacesToolbarItems");

          if (pti && !pti._placesNode)
            new PlacesToolbar("place:folder=TOOLBAR");
        }
        catch (err) {}
      }

      ah.bc.setAttribute("checked", true);
      ah.popup = null;
      return;
    }

    if (ah.zombie) {
      e.preventDefault();
      e.stopPropagation();
      ah.zombie = false;
    }

    ah.bc.setAttribute("checked", false);

    try {
      Services.obs.removeObserver(ah.MouseObserver, "ahMouseMove");
    }
    catch (e) {}

    gBrowser.tabContainer.removeEventListener("TabSelect", ah.EL_TabSelect, false);
    ah.tabViewDeck.removeEventListener("select", ah.EL_TabDeckSelect, true);

    if (!ah.noFloat && ah.topVis)
      ah.MoveContent(false);

    ah.menuBar.removeEventListener("DOMMenuBarActive", ah.EL_MenuBar, true);
    ah.menuBar.removeEventListener("DOMMenuBarInactive", ah.EL_MenuBar, true);
    removeEventListener("popupshown", ah.EL_Popup, false);
    removeEventListener("popuphidden", ah.EL_Popup, false);
    removeEventListener("mousemove", ah.EL_MouseMove, true);
    removeEventListener("keypress", ah.EL_Input, true);
    removeEventListener("DOMNodeInserted", ah.EL_Print, false);
    removeEventListener("DOMNodeRemoved", ah.EL_Print, false);

    setTimeout(function () {
      while (document.getElementsByAttribute("ahHIDE", "*").length) {
        var elt = document.getElementsByAttribute("ahHIDE", "*")[0];
        elt.removeAttribute("ahHIDE");
        elt.removeAttribute("ahPOS");

        if (elt.hasAttribute("ahPREVCOLLAPSED")) {
          elt.setAttribute("collapsed", elt.getAttribute("ahPREVCOLLAPSED"));
          elt.removeAttribute("ahPREVCOLLAPSED");
        }
      }

      if (ah.winUtil) {
        if (ah.withoutCaption) {
          ah.mainWin.setAttribute("chromemargin", ah.chromeMargin);
          ah.withoutCaption = false;
        }

        ah.winUtil.goFull(ah.handle, 0);
      }
    }, 0)
  },

  ChangeCommand : function(items, text) {
    for (var x = 0; x < items.length; x++) {
      var item = document.getElementById(items[x])

      if (item) {
        var cmd = item.getAttribute("oncommand");
        item.removeAttribute("oncommand");
        item.setAttribute("oncommand", text + cmd);
      }
    }
  },

  EL_Print : function(e) {
    if (e.target && e.target.id && e.target.id == "print-preview-toolbar") {
      var ah = autoHIDE;

      if (e.type == "DOMNodeInserted") {
        ah.mainWin.setAttribute("ahPRINTMODE", true);

        if (ah.topVis)
          ah.ToggleTop();

        if (ah.zombie && !ah.withoutCaption && ah.chromeMargin) {
          ah.titleBar.setAttribute("ahHIDE", true);
          ah.mainWin.removeAttribute("chromemargin");
        }
      }
      else {
        ah.mainWin.removeAttribute("ahPRINTMODE");

        if (ah.zombie && !ah.withoutCaption && ah.chromeMargin) {
          ah.titleBar.removeAttribute("ahHIDE");
          ah.mainWin.setAttribute("chromemargin", ah.chromeMargin);
        }
      }
    }
  },

  CheckOverNode : function(node) {
    var bx = node.boxObject;
    var ah = autoHIDE;

    if (ah.mx >= bx.screenX &&
        ah.mx <= bx.screenX + bx.width &&
        ah.my >= bx.screenY &&
        ah.my <= bx.screenY + bx.height)
      return true;
    else
      return false;
  },

  ShowToolBar : function(aNode) {
    var ah = autoHIDE;

    while (aNode != null && aNode != document) {
      if (aNode.localName == "toolbar") {
        if (aNode.getAttribute("ahHIDE") == "true") {
          var toolbars = new Array();
          toolbars[aNode.id] = true;

          var isTop = (aNode.getAttribute("ahPOS") == "top") ?  true : false;

          if (isTop && ah.topVis || !isTop && ah.bottomVis) {
            var aBoxC = (isTop) ?  ah.navBoxC : ah.botBoxC;

            for (var x=0; x < aBoxC.length; x++) {
              if (aBoxC[x].getAttribute("ahHIDE") == "false")
                toolbars[aBoxC[x].id] = true;
            }
          }

          if (isTop) {
            if (ah.topVis)
              ah.ToggleTop();

            ah.ToggleTop(toolbars);
          }
          else {
            if (ah.bottomVis)
              ah.ToggleBottom();

            ah.ToggleBottom(toolbars);
          }
        }

        break;
      }

      aNode = aNode.parentNode;
    }
  },

  HideToolBar : function(aNode) {
    var ah = autoHIDE;
    var cond = ah.topVis;
    var box = ah.navBox;
    var func = ah.ToggleTop;

    if (aNode.getAttribute("ahPOS") == "bottom") {
      cond = ah.bottomVis;
      box = ah.botBox;
      func = ah.ToggleBottom;
    }

    if (cond && !ah.CheckOverNode(box))
      func();
  },

  EL_Context : function(e) {
    if (e.target.id != "contentAreaContextMenu")
      return;

    var cMenu = document.getElementById("context-toggle-fullscreen")
    cMenu.hidden = cMenu.previousSibling.hidden = true

    if ((!document.getElementById("context-back").hasAttribute("hidden") ||
         !document.getElementById("context-viewimage").hasAttribute("hidden")) &&
         !this.GetBoolPref("noContext"))
      cMenu.hidden = cMenu.previousSibling.hidden = false;
  },

  EL_MenuBar : function(e) {
    var ah = autoHIDE;

    if (e.type == "DOMMenuBarActive") {
      ah.menuBar.removeAttribute("inactive");
      ah.ShowToolBar(ah.menuBar);
    }
    else
      ah.HideToolBar(ah.menuBar);
  },

  EL_Popup : function(e) {
    var aNode = e.originalTarget;
    var ah = autoHIDE;

    if (aNode.nodeName != "tooltip" && aNode.id != "abp-objtab") {
      if (e.type == "popupshown" && !ah.popup)
        ah.popup = aNode;

      if (e.type == "popuphidden" && aNode == ah.popup)
        ah.popup = null;
    }
  },

  EL_Input : function(e) {
    if (e.keyCode == KeyEvent.DOM_VK_RETURN) {
      if (autoHIDE.topVis)
        autoHIDE.ToggleTop();

      if (autoHIDE.bottomVis)
        autoHIDE.ToggleBottom();
    }

    if (e.keyCode == KeyEvent.DOM_VK_F6)
      autoHIDE.ShowToolBar(gURLBar);
  },

  EL_Location : function(target) {
    var elt = document.getElementById(target);

    if (elt)
      autoHIDE.ShowToolBar(elt);
  },

  EL_MouseMove : function(e) {
    var ah = autoHIDE;
    ah.mx = e.screenX;
    ah.my = e.screenY;

    if (ah.popup && ah.popup.state && ah.popup.state == "closed")
      ah.popup = null;

    if (ah.popup)
      return;

    if (ah.timerTop) {
      clearTimeout(ah.timerTop);
      ah.timerTop = null;
    }

    if (ah.timerBottom) {
      clearTimeout(ah.timerBottom);
      ah.timerBottom = null;
    }

    if ((("mgGestureState" in window) && mgGestureState.inProgress) || TabView.isVisible())
      return;

    if (!ah.topVis && (ah.my <= ah.navBox.boxObject.screenY - ah.topArea) && !gInPrintPreviewMode)
      ah.timerTop = setTimeout("autoHIDE.ToggleTop()", ah.delay);

    if (ah.topVis && ah.my > (ah.navBox.boxObject.screenY + ah.navBox.boxObject.height + 50))
      ah.timerTop = setTimeout("autoHIDE.ToggleTop()", ah.hideDelay);

    if (!ah.bottomVis && ah.my >= (ah.botBox.boxObject.screenY + ah.botBox.boxObject.height + ah.bottomArea))
      ah.timerBottom = setTimeout("autoHIDE.ToggleBottom()", ah.delay);

    if (ah.bottomVis && ah.my < ah.botBox.boxObject.screenY -50)
      ah.timerBottom = setTimeout("autoHIDE.ToggleBottom()", ah.hideDelay);
  },

  EL_TabSelect : function(e) {
    if (autoHIDE.topVis && !gBrowser.mCurrentBrowser.ahMarginSet)
      autoHIDE.MoveContent(true);
  },

  EL_TabDeckSelect : function(e) {
    if (e.target == autoHIDE.tabViewDeck)
      autoHIDE.ShowToolBar(autoHIDE.tabBar);
  }
}

// == Ugly Overrides ==

function onFullScreen(e) {
  var ah = autoHIDE;

  if (!fullScreen && !ah.zombie) {
    ah.chromeMargin = ah.mainWin.getAttribute("chromemargin");

    try {
      if (!ah.updateAppButtonDisplay)
        ah.updateAppButtonDisplay = updateAppButtonDisplay;

      updateAppButtonDisplay = new Function();
    }
    catch (err) {}

    if (ah.openMaximized) {
      ah.openMaximized = false;
      window.maximize();
    }

    ah.InitHide(e);

    if (!ah.zombie)
      FullScreen.showXULChrome("toolbar", false);

    setTimeout("autoHIDE.ResetTop(true)", 0);
    ah.mainWin.setAttribute("ahHIDEMODE", !ah.noFloat);

    return;
  }

  if (fullScreen || ah.zombie) {
    ah.InitHide(e);

    if (ah.updateAppButtonDisplay)
      updateAppButtonDisplay = ah.updateAppButtonDisplay;

    FullScreen.showXULChrome("toolbar", true);
    ah.mainWin.removeAttribute("ahHIDEMODE");
    ah.mainWin.removeAttribute("ahHIDETITLEBAR");

    TabsInTitlebar._update();
  }
}

addEventListener("load", function(){autoHIDE.GetCMDLine()}, false);