Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");

const Cc = Components.classes;
const Ci = Components.interfaces;
const obsService = Cc["@mozilla.org/observer-service;1"].getService(Ci.nsIObserverService);

function ahHandleFullscreen() {}
ahHandleFullscreen.prototype = {
  handle : function autohide_clh_handle(cmdline) {
    if (cmdline.handleFlag("fullscreen", false)) {
       var ahpref = Cc["@mozilla.org/preferences-service;1"]
                   .getService(Ci.nsIPrefService).getBranch("extensions.autohide.");

       ahpref.setBoolPref("openFull", true);
    }
  },

  helpInfo : "  -fullscreen           Start app in full screen mode.\n",

  classDescription: "Autohide Fullscreen Cmdline Handler",
  classID: Components.ID("{DD23C6C4-0884-43f9-8E6A-5DBBE13F7346}"),
  contractID: "@krickelkrackel/browser/fullscreen-clh;1",
  QueryInterface: XPCOMUtils.generateQI([Ci.nsICommandLineHandler]),
  _xpcom_categories: [{category: "command-line-handler", entry: "m-fullscreen"}]
};

var NSGetFactory = XPCOMUtils.generateNSGetFactory([ahHandleFullscreen]);