var EXPORTED_SYMBOLS = ["autoHIDESystemHook"];
Components.utils.import("resource://gre/modules/Services.jsm");

var autoHIDESystemHook = {
  init : false,

  mainInit : function() {
    if (this.init)
      return;

    this.init = true;

    try {
      var appInfo = Services.appinfo;

      var suffix = ".dll";

      if (appInfo.OS == "Linux")
        suffix = ".so";
      if (appInfo.OS == "Darwin")
        suffix = ".dylib";

      var binPath = "resource://autohide/binary/ahWinUtils_" + appInfo.OS + "_" + appInfo.XPCOMABI + suffix;
      var file = Services.io.newURI(binPath, null, null).QueryInterface(Components.interfaces.nsIFileURL).file

      this.loadBinary(file.path, appInfo.OS);
    }
    catch (err) {
      this.winUtil = null;
    }
  },

  loadBinary : function(binaryFile, OS) {
    Components.utils.import("resource://gre/modules/ctypes.jsm");

    try {
      this.winUtil.bin = ctypes.open(binaryFile);

      this.winUtil.setPrefs = this.winUtil.bin.declare("setPrefs", ctypes.default_abi, ctypes.void_t, ctypes.int, ctypes.bool, ctypes.bool);

      this.winUtil.winInit = this.winUtil.bin.declare("winInit", ctypes.default_abi, ctypes.long);
      this.winUtil.goFull = this.winUtil.bin.declare("goFull", ctypes.default_abi, ctypes.void_t, ctypes.long, ctypes.int);
      this.winUtil.setRedraw = this.winUtil.bin.declare("setRedraw", ctypes.default_abi, ctypes.void_t, ctypes.long, ctypes.bool);
      
      this.winUtil.isMouseOver = this.winUtil.bin.declare("isMouseOver", ctypes.default_abi, ctypes.bool, ctypes.long);
      this.winUtil.isAutoHidden = this.winUtil.bin.declare("isAutoHidden", ctypes.default_abi, ctypes.bool);
      this.winUtil.isShiftDown = this.winUtil.bin.declare("isShiftDown", ctypes.default_abi, ctypes.bool);
      this.winUtil.supports = this.winUtil.bin.declare("supports", ctypes.default_abi, ctypes.bool, ctypes.char.ptr);

      this.winUtil.returnFuncType = new ctypes.FunctionType((OS == "WINNT") ? ctypes.stdcall_abi : ctypes.default_abi, ctypes.voidptr_t, [ctypes.int, ctypes.int]).ptr;
      this.winUtil.mainInit = this.winUtil.bin.declare("mainInit", ctypes.default_abi, ctypes.void_t, this.winUtil.returnFuncType);
      this.winUtil.callBack = new this.winUtil.returnFuncType(this.winUtil.onMouseMove);
      this.winUtil.mainInit(this.winUtil.callBack);
    }
    catch (err) {
      dump("Autohide: " + err + "\n");
      this.winUtil = null;
      return;
    }

  },

  winUtil : {
    onMouseMove : function (screenX, screenY) {
      Services.obs.notifyObservers(null, "ahMouseMove", screenX + "|" + screenY);
    }
  }
}

autoHIDESystemHook.mainInit();